library ieee;
use ieee.std_logic_1164.all;	   
use ieee.numeric_std.all;
library rfsm;
use rfsm.core.all;

entity tb is
end tb;

architecture Bench of tb is

component a1 
  port(
        h: in std_logic;
        o1: out integer;
        o2: out integer;
        rst: in std_logic
        );
end component;

signal h: std_logic;
signal o2: integer;
signal o1: integer;
signal rst: std_logic;

begin

  inp_h: process
    type t_periodic is record period: time; t1: time; t2: time; end record;
    constant periodic : t_periodic := ( 9 ns, 10 ns, 100 ns );
    variable t : time := 0 ns;
    begin
      h <= '0';
      wait for periodic.t1;
      notify_ev(h,1 ns);
      while ( t < periodic.t2 ) loop
        wait for periodic.period;
        notify_ev(h,1 ns);
        t := t + periodic.period;
      end loop;
      wait;
  end process;

  U0: A1 port map(h,o1,o2,rst);

  process

  begin
    rst <= '1';
    wait for 1 ns;
    rst <= '0';
    wait for 100 ns;
    wait;

  end process;
end Bench;
