#include "systemc.h"
#include "rfsm.h"
#include "inp_U.h"
#include "inp_Start.h"
#include "inp_H.h"
#include "heron.h"

int sc_main(int argc, char *argv[])
{
  sc_signal<float> U;
  sc_signal<int> Start;
  sc_signal<bool> H;
  sc_signal<float> R;
  sc_signal<int> Rdy;
  sc_trace_file *trace_file;
  trace_file = sc_create_vcd_trace_file ("tb");
  sc_trace(trace_file, U, "U");
  sc_trace(trace_file, Start, "Start");
  sc_trace(trace_file, H, "H");
  sc_trace(trace_file, R, "R");
  sc_trace(trace_file, Rdy, "Rdy");

  Inp_U Inp_U("Inp_U");
  Inp_U(U);
  Inp_Start Inp_Start("Inp_Start");
  Inp_Start(Start);
  Inp_H Inp_H("Inp_H");
  Inp_H(H);

  Heron heron("heron");
  heron(H,Start,U,Rdy,R);

  sc_start(200, SC_NS);

  sc_close_vcd_trace_file (trace_file);

  return EXIT_SUCCESS;
}
