(* Emet "Gagne" a chaque occurrence de trois "Pile" consecutifs *)

open Rfsm
open Expr
open Types
open Action
  
let pf = Fsm.build_model
  ~name:"pf"
  ~states:["P0"; "P1"; "P2"]
  ~params:[]
  ~inps:["Pile", TyEvent; "Face", TyEvent]
  ~outps:["Gagne", TyEvent]
  ~vars:[]
  ~trans:[
    ("P0", ("Face",[]), [], "P0"); 
    ("P0", ("Pile",[]), [], "P1"); 
    ("P1", ("Face",[]), [], "P0"); 
    ("P1", ("Pile",[]), [], "P2"); 
    ("P2", ("Face",[]), [], "P0"); 
    ("P2", ("Pile",[]), [Emit "Gagne"], "P2"); 
    ]
  ~itrans:("P0",[])

let pile = Fsm.GInp ("Pile", TyEvent, Sporadic [20; 40; 50; 70; 80; 90; 110; 120; 130; 140])
let face = Fsm.GInp ("Face", TyEvent, Sporadic [10; 30; 60; 150])
let gagne = Fsm.GOutp ("Gagne", TyEvent)

let pf = Fsm.build_instance ~name:"pf" ~model:pf ~params:[] ~inps:[pile;face] ~outps:[gagne]

let p = Comp.build_composite "game" [pf]

let _ = Comp.dot_output "./dot" p

let c, rs = Simul.run p
let _ = List.iter Simul.dump_reaction rs
