library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library rfsm;
use rfsm.core.all;

entity s is
  port(
        h: in std_logic;
        start: in boolean;
        x: in integer;
        rdy: out boolean;
        r: out integer;
        rst: in std_logic
        );
end s;

architecture RTL of s is
  type t_state is ( Calcul1, Calcul2, Repos );
  signal state: t_state;
begin
  process(rst, h)
  variable u: integer;
  variable z: integer;
  variable y: integer;
  variable t: boolean;
  begin
    if ( rst='1' ) then
      state <= Repos;
      rdy <= true;
    elsif rising_edge(h) then 
      case state is
      when Repos =>
        if ( start = true ) then
          y := x;
          u := 1;
          rdy <= false;
          state <= Calcul1;
        end if;
      when Calcul2 =>
        if ( u<=1 ) then
          r <= z/2;
          rdy <= true;
          state <= Repos;
        elsif  ( u>1 ) then
          u := u/4;
          z := (z/2)-u;
          t := z<=y;
          y := cond(t,y-z,y);
          z := cond(t,z+(u*2),z);
        end if;
      when Calcul1 =>
        if ( u<=y ) then
          u := u*4;
        elsif  ( u>y ) then
          z := u;
          state <= Calcul2;
        end if;
    end case;
    end if;
  end process;
end RTL;
