#include "systemc.h"
#include "rfsm.h"
#include "inp_H2.h"
#include "inp_H1.h"
#include "A1_1.h"
#include "A2_1.h"

int sc_main(int argc, char *argv[])
{
  sc_signal<bool> H2;
  sc_signal<bool> H1;
  sc_signal<int,SC_MANY_WRITERS> v;
  sc_signal<int> A1_1_state;
  sc_signal<int> A2_1_state;
  sc_trace_file *trace_file;
  trace_file = sc_create_vcd_trace_file ("tb");
  sc_trace(trace_file, H2, "H2");
  sc_trace(trace_file, H1, "H1");
  sc_trace(trace_file, v, "v");
  sc_trace(trace_file, A1_1_state, "A1_1_state");
  sc_trace(trace_file, A2_1_state, "A2_1_state");

  Inp_H2 Inp_H2("Inp_H2");
  Inp_H2(H2);
  Inp_H1 Inp_H1("Inp_H1");
  Inp_H1(H1);

  A1_1 A1_1("A1_1");
  A1_1(H1,v,A1_1_state);
  A2_1 A2_1("A2_1");
  A2_1(H2,v,A2_1_state);

  sc_start(100, SC_NS);

  sc_close_vcd_trace_file (trace_file);

  return EXIT_SUCCESS;
}
