#include "systemc.h"
#include "rfsm.h"
#include "inp_H.h"
#include "a1.h"
#include "a2.h"
#include "a3.h"

int sc_main(int argc, char *argv[])
{
  sc_signal<bool> H;
  sc_signal<bool,SC_MANY_WRITERS> v2;
  sc_signal<bool,SC_MANY_WRITERS> v1;
  sc_signal<int> a1_state;
  sc_signal<int> a2_state;
  sc_signal<int> a3_state;
  sc_trace_file *trace_file;
  trace_file = sc_create_vcd_trace_file ("tb");
  sc_trace(trace_file, H, "H");
  sc_trace(trace_file, v2, "v2");
  sc_trace(trace_file, v1, "v1");
  sc_trace(trace_file, a1_state, "a1_state");
  sc_trace(trace_file, a2_state, "a2_state");
  sc_trace(trace_file, a3_state, "a3_state");

  Inp_H Inp_H("Inp_H");
  Inp_H(H);

  A1 a1("a1");
  a1(H,v1,a1_state);
  A2 a2("a2");
  a2(H,v2,v1,a2_state);
  A3 a3("a3");
  a3(H,v2,a3_state);

  sc_start(100, SC_NS);

  sc_close_vcd_trace_file (trace_file);

  return EXIT_SUCCESS;
}
