#include "systemc.h"
#include "rfsm.h"
#include "inp_x0.h"
#include "inp_Start.h"
#include "inp_H.h"
#include "c1.h"

int sc_main(int argc, char *argv[])
{
  sc_signal<int> x0;
  sc_signal<bool> Start;
  sc_signal<bool> H;
  sc_signal<int> n;
  sc_signal<bool> Rdy;
  sc_trace_file *trace_file;
  trace_file = sc_create_vcd_trace_file ("tb");
  sc_trace(trace_file, x0, "x0");
  sc_trace(trace_file, Start, "Start");
  sc_trace(trace_file, H, "H");
  sc_trace(trace_file, n, "n");
  sc_trace(trace_file, Rdy, "Rdy");

  Inp_x0 Inp_x0("Inp_x0");
  Inp_x0(x0);
  Inp_Start Inp_Start("Inp_Start");
  Inp_Start(Start);
  Inp_H Inp_H("Inp_H");
  Inp_H(H);

  C1 c1("c1");
  c1(H,Start,x0,Rdy,n);

  sc_start(100, SC_NS);

  sc_close_vcd_trace_file (trace_file);

  return EXIT_SUCCESS;
}
