library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library rfsm;
use rfsm.core.all;

entity c1 is
  port(
        h: in std_logic;
        start: in std_logic;
        x0: in integer;
        rdy: out std_logic;
        n: out integer;
        rst: in std_logic
        );
end c1;

architecture RTL of c1 is
  type t_state is ( Calcul, Repos );
  signal state: t_state;
  signal x: integer;
  signal k: integer;
begin
  process(rst, h)
  begin
    if ( rst='1' ) then
      state <= Repos;
      rdy <= '1';
    elsif rising_edge(h) then 
      case state is
      when Repos =>
        if ( start = '1' ) then
          x <= x0;
          k <= 1;
          rdy <= '0';
          state <= Calcul;
        end if;
      when Calcul =>
        if ( x /= 1 and x mod 2 = 0 ) then
          x <= x/2;
          k <= k+1;
        elsif  ( x /= 1 and x mod 2 = 1 ) then
          x <= 3*x+1;
          k <= k+1;
        elsif  ( x = 1 ) then
          n <= k;
          rdy <= '1';
          state <= Repos;
        end if;
    end case;
    end if;
  end process;
end RTL;
