library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library rfsm;
use rfsm.core.all;

entity f1 is
  port(
        h: in std_logic;
        u: in unsigned(0 downto 0);
        o: out integer;
        rst: in std_logic
        );
end f1;

architecture RTL of f1 is
  type t_state is ( E0, E1 );
  signal state: t_state;
  signal v: unsigned(0 downto 0);
begin
  process(rst, h)
  begin
    if ( rst='1' ) then
      state <= E0;
    elsif rising_edge(h) then 
      case state is
      when E1 =>
        if ( u = to_unsigned(0,1) ) then
          o <= 0;
          state <= E0;
        end if;
      when E0 =>
        o <= 1;
        v <= to_unsigned(1,1);
        state <= E1;
    end case;
    end if;
  end process;
end RTL;
