library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library rfsm;
use rfsm.core.all;

entity foo1 is
  port(
        h: in std_logic;
        u: in unsigned(1 downto 0);
        o: out unsigned(1 downto 0);
        rst: in std_logic
        );
end foo1;

architecture RTL of foo1 is
  type t_state is ( E0, E1 );
  signal state: t_state;
begin
  process(rst, h)
  begin
    if ( rst='1' ) then
      state <= E0;
    elsif rising_edge(h) then 
      case state is
      when E1 =>
        if ( u>to_unsigned(0,2) ) then
          o <= to_unsigned(2,2);
          state <= E0;
        end if;
      when E0 =>
        o <= to_unsigned(4,2);
        state <= E1;
    end case;
    end if;
  end process;
end RTL;
