library ieee;
use ieee.std_logic_1164.all;	   
use ieee.numeric_std.all;
library rfsm;
use rfsm.core.all;

entity tb is
end tb;

architecture Bench of tb is

component foo1 
  port(
        h: in std_logic;
        u: in unsigned(1 downto 0);
        o: out unsigned(1 downto 0);
        rst: in std_logic
        );
end component;

signal U: unsigned(1 downto 0);
signal H: std_logic;
signal O: unsigned(1 downto 0);
signal rst: std_logic;

begin

  inp_U: process
    type t_vc is record date: time; val: unsigned(1 downto 0); end record;
    type t_vcs is array ( 0 to 1 ) of t_vc;
    constant vcs : t_vcs := ( (0 ns,to_unsigned(0,2)), (50 ns,to_unsigned(2,2)) );
    variable i : natural := 0;
    variable t : time := 0 ns;
    begin
      for i in 0 to 1 loop
        wait for vcs(i).date-t;
        U <= vcs(i).val;
        t := vcs(i).date;
      end loop;
      wait;
  end process;
  inp_H: process
    type t_periodic is record period: time; t1: time; t2: time; end record;
    constant periodic : t_periodic := ( 9 ns, 10 ns, 110 ns );
    variable t : time := 0 ns;
    begin
      H <= '0';
      wait for periodic.t1;
      notify_ev(H,1 ns);
      while ( t < periodic.t2 ) loop
        wait for periodic.period;
        notify_ev(H,1 ns);
        t := t + periodic.period;
      end loop;
      wait;
  end process;

  U0: Foo1 port map(H,U,O,rst);

  process

  begin
    rst <= '1';
    wait for 1 ns;
    rst <= '0';
    wait for 100 ns;
    wait;

  end process;
end Bench;
