// This file is automatically generated by scxmlcc (version 0.8.3)
// For more information, see http://scxmlcc.org

#ifndef __SC_GENSIG
#define __SC_GENSIG

#include <queue>

class sc_gensig
{
	public:

	struct data_model;
	struct user_model;

	class state
	{
		public:
		virtual state* event_H(sc_gensig&) { return 0; }
		virtual state* unconditional(sc_gensig&) { return 0; }
		virtual state* initial(sc_gensig&) { return 0; }

		template<class T> void enter(data_model&, ...) {}
		template<class T> void exit(data_model&, ...) {}
	};

	state *cur_state;
	typedef state* (state::*event)(sc_gensig&);

	struct data_model
	{
		std::queue<event> event_queue;
		user_model *user;
		int e;
		int s;
		data_model() : e(0), s(0) {}
	} model;

	template<class C> class state_actions
	{
		protected:
		void enter(data_model&) {} // default enter action
		void exit(data_model&) {} // default exit action
	};

	template<class C, class P> class composite : public P, public state_actions<C>
	{
		virtual state* initial(sc_gensig&) { return 0; }
		public:
		typedef P parent_t;
		// LCA calculation
		template<class T> void enter(data_model&, composite*) {}
		template<class T> void enter(data_model &m, ...) { P::template enter<T>(m, (T*)0); state_actions<C>::enter(m); }
		template<class T> void exit(data_model&, composite*) {}
		template<class T> void exit(data_model &m, ...) { state_actions<C>::exit(m); P::template exit<T>(m, (T*)0); }
	};

	class no_state {};
	enum transition_type { external, internal };

	template<event E, class S, class D0 = no_state> class transition_actions
	{
		protected:
		void enter(data_model&) {} // default enter action
		bool condition(data_model&) { return true; } // default condition action
	};

	// external/internal transition
	template<event E, class S, class D = no_state, transition_type T = external> class transition : public transition_actions<E, S, D>
	{
		template<transition_type I> struct id { };
		void state_enter(D* d, data_model &m, id<internal>, S*) { d->template enter<S>(m, (S*)0); };
		void state_enter(D* d, data_model &m, ...) { d->template enter<typename S::parent_t>(m); };
		void state_exit(S* s, data_model &m, id<internal>, S*) {};
		void state_exit(S* s, data_model &m, ...) { s->template exit<typename D::parent_t>(m); };
		public:
		state* operator ()(S *s, sc_gensig &sc)
		{
			if(!transition_actions<E, S, D>::condition(sc.model)) return 0;
			D *d = sc.new_state<D>();
			state_exit(s, sc.model, id<T>(), (typename D::parent_t*)0);
			transition_actions<E, S, D>::enter(sc.model);
			state_enter(d, sc.model, id<T>(), (typename D::parent_t*)0);
			return d;
		}
	};

	private: bool dispatch_event(event e)
	{
		state *next_state;
		if ((next_state = (cur_state->*e)(*this))) cur_state = next_state;
		return !!next_state;
	}

	public: void dispatch(event e)
	{
		bool cont = dispatch_event(e);
		while (cont) {
			if ((cont = dispatch_event(&state::initial)));
			else if ((cont = dispatch_event(&state::unconditional)));
			else if (model.event_queue.size()) cont = dispatch_event(model.event_queue.front()), model.event_queue.pop(), cont |= !model.event_queue.empty();
			else break;
		}
	}

	sc_gensig(user_model *user = 0) : cur_state(new_state<scxml>())
	{
		model.user = user;
	}

	void init() { dispatch(&state::initial); }

	class scxml : public composite<scxml, state>
	{
		state* initial(sc_gensig&sc) { return transition<&state::initial, scxml, state_E0, internal>()(this, sc); }
	};

	struct state_E0 : public composite<state_E0, scxml>
	{
		state* event_H(sc_gensig &sc) { return transition<&state::event_H, state_E0, state_E1>()(this, sc); }
	};

	struct state_E1 : public composite<state_E1, scxml>
	{
		state* event_H(sc_gensig &sc) { return transition<&state::event_H, state_E1, state_E2>()(this, sc); }
	};

	struct state_E2 : public composite<state_E2, scxml>
	{
		state* event_H(sc_gensig &sc) { return transition<&state::event_H, state_E2, state_E3>()(this, sc); }
	};

	struct state_E3 : public composite<state_E3, scxml>
	{
		state* event_H(sc_gensig &sc) { return transition<&state::event_H, state_E3, state_E0>()(this, sc); }
	};

	template<class T> T* new_state()
	{
		static T t;
		return &t;
	};
};

template<> void sc_gensig::transition_actions<&sc_gensig::state::event_H, sc_gensig::state_E0, sc_gensig::state_E1>::enter(sc_gensig::data_model &m)
{
	struct with : sc_gensig::data_model { void operator ()() { // 'with' construct, to bring model variables in scope
		s = 1;
	}}; static_cast<with&>(m)();
}

template<> bool sc_gensig::transition_actions<&sc_gensig::state::event_H, sc_gensig::state_E0, sc_gensig::state_E1>::condition(sc_gensig::data_model &m)
{
	struct with : sc_gensig::data_model { bool operator ()() { // 'with' construct, to bring model variables in scope
		return e=1;
	}}; return static_cast<with&>(m)();
}

template<> void sc_gensig::transition_actions<&sc_gensig::state::event_H, sc_gensig::state_E3, sc_gensig::state_E0>::enter(sc_gensig::data_model &m)
{
	struct with : sc_gensig::data_model { void operator ()() { // 'with' construct, to bring model variables in scope
		s = 0;
	}}; static_cast<with&>(m)();
}

#endif
