#include "gensig.h"
#include "termio.h"
#include <iostream>

using namespace std;

typedef sc_timer_switch sc;

// struct sc::user_model 
// {
// };

template<> void sc::state_actions<sc::state_E0>::enter(sc::data_model &m)
{
	cout << "Entering state E0" << endl;	
}

template<> void sc::state_actions<sc::state_E1>::enter(sc::data_model &m)
{
	cout << "Entering state E1" << endl;	
}

template<> void sc::state_actions<sc::state_E2>::enter(sc::data_model &m)
{
	cout << "Entering state E2" << endl;	
}

template<> void sc::state_actions<sc::state_E3>::enter(sc::data_model &m)
{
	cout << "Entering state E3" << endl;	
}

int main(int argc, char *argv[])
{
	// set unbuffered input and disable echo
	termio t;
	t.echo(false);
	t.canonical(false);

	cout << "input:  0 = set e=0" << endl;
    cout << "        1 = set e=1" << endl;
    cout << "        h = raise h" << endl;
	cout << "        q = quit" << endl;

	// sc::user_model m;
	// sc sc(&m);
	sc sc();
	sc.init();

	while(true) {
		char c;	
		cin >> c;

		sc::event e;
		switch (c) {
			case 'b': e = &sc::state::event_button; break;
			case 't': e = &sc::state::event_timer;  break;
			case 'q': return 0;
			default: continue;
		}
		sc.dispatch(e);
	}
	return 0;
}

