#include "systemc.h"
#include "rfsm.h"
#include "inp_H2.h"
#include "inp_H1.h"
#include "inp_Top.h"
#include "A.h"
#include "B.h"

int sc_main(int argc, char *argv[])
{
  sc_signal<bool> H2;
  sc_signal<bool> H1;
  sc_signal<bool> Top;
  sc_signal<int> waited;
  sc_signal<bool> Ping;
  sc_signal<bool> Pong;
  sc_trace_file *trace_file;
  trace_file = sc_create_vcd_trace_file ("tb");
  sc_trace(trace_file, H2, "H2");
  sc_trace(trace_file, H1, "H1");
  sc_trace(trace_file, Top, "Top");
  sc_trace(trace_file, waited, "waited");
  sc_trace(trace_file, Ping, "Ping");
  sc_trace(trace_file, Pong, "Pong");

  Inp_H2 Inp_H2("Inp_H2");
  Inp_H2(H2);
  Inp_H1 Inp_H1("Inp_H1");
  Inp_H1(H1);
  Inp_Top Inp_Top("Inp_Top");
  Inp_Top(Top);

  A A("A");
  A(Top,H1,Pong,waited,Ping);
  B B("B");
  B(H2,Ping,Pong);

  sc_start(100, SC_NS);

  sc_close_vcd_trace_file (trace_file);

  return EXIT_SUCCESS;
}
